--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--Codec for LaunchPad - JammeR RE
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
function remote_init(manufacturer, model)

	--check this is the right model
    assert(model=="LP_Pro_JammeR")
    --define a table with all the items on the control surface
	local items={
		{name="Control 01", input="value", output="value", min=0, max=1},
		{name="Control 02", input="value", output="value", min=0, max=1},
		{name="Control 03", input="value", output="value", min=0, max=1},
		{name="Control 04", input="value", output="value", min=0, max=1},
		{name="Control 05", input="value", output="value", min=0, max=1},
		{name="Control 06", input="value", output="value", min=0, max=1},
		{name="Control 07", input="value", output="value", min=0, max=1},
		{name="Control 08", input="value", output="value", min=0, max=1},
		{name="Control 1", input="value", output="value", min=0, max=1},
		{name="Control 2", input="value", output="value", min=0, max=1},
		{name="Control 3", input="value", output="value", min=0, max=1},
		{name="Control 4", input="value", output="value", min=0, max=1},
		{name="Control 5", input="value", output="value", min=0, max=1},
		{name="Control 6", input="value", output="value", min=0, max=1},
		{name="Control 7", input="value", output="value", min=0, max=1},
		{name="Control 8", input="value", output="value", min=0, max=1},
		{name="Control 9", input="value", output="value", min=0, max=1},
		{name="Control 10", input="value", output="value", min=0, max=1},
		{name="Control 11", input="value", output="value", min=0, max=1},
		{name="Control 12", input="value", output="value", min=0, max=1},
		{name="Control 13", input="value", output="value", min=0, max=1},
		{name="Control 14", input="value", output="value", min=0, max=1},
		{name="Control 15", input="value", output="value", min=0, max=7},
		{name="Control 16", input="value", output="value", min=0, max=7},
		{name="Control 17", input="value", output="value", min=0, max=7},
		{name="Control 18", input="value", output="value", min=0, max=7},
		{name="Control 19", input="value", output="value", min=0, max=7},
		{name="Control 20", input="value", output="value", min=0, max=7},
		{name="Control 21", input="value", output="value", min=0, max=1},
		{name="Control 22", input="value", output="value", min=0, max=1},
		{name="Control 23", input="value", output="value", min=0, max=1},
		{name="Control 24", input="value", output="value", min=0, max=1},
		{name="Control 25", input="value", output="value", min=0, max=1},
		{name="Control 26", input="value", output="value", min=0, max=1},
		{name="Control 27", input="value", output="value", min=0, max=1},
		{name="Control 28", input="value", output="value", min=0, max=1},
		{name="Control 29", input="value", output="value", min=0, max=1},
		{name="Control 30", input="value", output="value", min=0, max=1},
		{name="Control 31", input="value", output="value", min=0, max=1},
		{name="Control 32", input="value", output="value", min=0, max=1},
		{name="Control 33", input="value", output="value", min=0, max=1},
		{name="Control 34", input="value", output="value", min=0, max=1},
		{name="Control 35", input="value", output="value", min=0, max=1},
		{name="Control 36", input="value", output="value", min=0, max=1},
		{name="Control 37", input="value", output="value", min=0, max=1},
		{name="Control 38", input="value", output="value", min=0, max=1},
		{name="Control 39", input="value", output="value", min=0, max=1},
		{name="Control 40", input="value", output="value", min=0, max=1},
		{name="Control 41", input="value", output="value", min=0, max=1},
		{name="Control 42", input="value", output="value", min=0, max=1},
		{name="Control 43", input="value", output="value", min=0, max=1},
		{name="Control 44", input="value", output="value", min=0, max=1},
		{name="Control 45", input="value", output="value", min=0, max=1},
		{name="Control 46", input="value", output="value", min=0, max=1},
		{name="Control 47", input="value", output="value", min=0, max=1},
		{name="Control 48", input="value", output="value", min=0, max=1},
		{name="Control 49", input="value", output="value", min=0, max=1},
		{name="Control 50", input="value", output="value", min=0, max=1},
		{name="Control 51", input="value", output="value", min=0, max=1},
		{name="Control 52", input="value", output="value", min=0, max=1},
		{name="Control 53", input="value", output="value", min=0, max=1},
		{name="Control 54", input="value", output="value", min=0, max=1},
		{name="Control 55", input="value", output="value", min=0, max=1},
		{name="Control 56", input="value", output="value", min=0, max=1},
		{name="Control 57", input="value", output="value", min=0, max=1},
		{name="Control 58", input="value", output="value", min=0, max=1},
		{name="Control 59", input="value", output="value", min=0, max=1},
		{name="Control 60", input="value", output="value", min=0, max=1},
		{name="Control 61", input="value", output="value", min=0, max=1},
		{name="Control 62", input="value", output="value", min=0, max=1},
		{name="Control 63", input="value", output="value", min=0, max=1},
		{name="Control 64", input="value", output="value", min=0, max=1},
		{name="Control 65", input="value", output="value", min=0, max=1},
		{name="Control 66", input="value", output="value", min=0, max=1},
		{name="Control 67", input="value", output="value", min=0, max=1},
		{name="Control 68", input="value", output="value", min=0, max=1},
		{name="Control 69", input="value", output="value", min=0, max=1},
		{name="Control 70", input="value", output="value", min=0, max=1},
		{name="Control 71", input="value", output="value", min=0, max=1},
		{name="Control 72", input="value", output="value", min=0, max=1},
		{name="Control 73", input="value", output="value", min=0, max=1},
		{name="Control 74", input="value", output="value", min=0, max=1},
		{name="Control 75", input="value", output="value", min=0, max=1},
		}
	remote.define_items(items)	
end
function remote_probe(manufacturer,model)
assert(model=="LP_Pro_JammeR")
return {
request="f0 7e 7f 06 01 f7",
response="f0 7e 7f 06 02 56 66 66 01 03 ?? ?? ?? ?? f7"
}
end
asdgfote = {1, 2, 3, 4, 5, 6, 7, 8}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
dfa34wras = {17, 18, 19, 20, 21, 22}
uiqwassr = {23, 24, 25, 26, 27, 28}
lkjvcds = {9, 10, 11, 12, 13, 14, 15, 16}
gfhjrsvb = {0, 0, 0, 0, 0, 0, 0, 0}
chjklwfd =  {0, 0, 0, 0, 0, 0, 0, 0}
tcvnfhso ={}
pafgskjl={}
nfsvsxvzz ={}
for i =1, 48, 1 do
table.insert(tcvnfhso, 28+i)
table.insert(pafgskjl, 0)
table.insert(nfsvsxvzz, 0)
end
lnswegfd = {"<100x>? 51 yy", "<100x>? 52 yy", "<100x>? 53 yy", "<100x>? 54 yy", "<100x>? 55 yy", "<100x>? 56 yy", 
"<100x>? 47 yy", "<100x>? 48 yy", "<100x>? 49 yy", "<100x>? 4a yy", "<100x>? 4b yy", "<100x>? 4c yy", 
"<100x>? 3d yy", "<100x>? 3e yy", "<100x>? 3f yy", "<100x>? 40 yy", "<100x>? 41 yy", "<100x>? 42 yy", 
"<100x>? 33 yy", "<100x>? 34 yy", "<100x>? 35 yy", "<100x>? 36 yy", "<100x>? 37 yy", "<100x>? 38 yy",  
"<100x>? 29 yy", "<100x>? 2a yy", "<100x>? 2b yy", "<100x>? 2c yy", "<100x>? 2d yy", "<100x>? 2e yy",  
"<100x>? 1f yy", "<100x>? 20 yy", "<100x>? 21 yy", "<100x>? 22 yy", "<100x>? 23 yy", "<100x>? 24 yy", 
"<100x>? 15 yy", "<100x>? 16 yy", "<100x>? 17 yy", "<100x>? 18 yy", "<100x>? 19 yy", "<100x>? 1a yy",  
"<100x>? 0b yy", "<100x>? 0c yy", "<100x>? 0d yy", "<100x>? 0e yy", "<100x>? 0f yy", "<100x>? 10 yy",}
bklkdsret = {"b0 59 xx", "<b0 4f xx", "<b0 45 xx", "<b0 3B xx", "<b0 31 xx", 
"<b0 27 xx", "<b0 1D xx", "<b0 13 xx"}
pommnjhg = {89, 79, 69, 59, 49, 39, 29, 19}
ertgfsdgb = {81, 82, 83, 84, 85, 86, 71, 72, 73, 74, 75, 76, 61, 62, 63, 64, 65, 66,
51, 52, 53, 54, 55, 56, 41, 42, 43, 44, 45, 46, 31, 32, 33, 34, 35, 36, 21, 22, 23, 24, 25, 26, 
11, 12, 13, 14, 15, 16}
kxcver = 0
tslkfgnxz =0
nbtygllo = "<b0 62 xx"
lklertgzq = 77
sdf45weio = {78, 79, 80, 81, 82, 83}
function remote_process_midi(event)
for i = 1, 8, 1 do 
local jpioretvvc = remote.match_midi(bklkdsret[i], mhjk4we)
if jpioretvvc ~= nil then 
if kxcver == 0 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=asdgfote[i], value= jpioretvvc.x/127}
remote.handle_input(msg)
return true
elseif kxcver == 1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= jpioretvvc.x/127}
remote.handle_input(msg2)
return true
end	
end
end
local sdfhaae9ut = 0
for i = 1, 48, 1 do 
local jpioretvvc = remote.match_midi(lnswegfd[i], mhjk4we)
if jpioretvvc ~= nil then 
local reneeder = i - math.floor(i/6)*6
local valogshi = 0
if reneeder == 0 then
sdfhaae9ut = 6
valogshi = i/6 - 1
else
sdfhaae9ut = reneeder
valogshi = math.floor(i/6)
end
if kxcver == 0 then 			
local msg = {time_stamp=mhjk4we.time_stamp, item=dfa34wras[sdfhaae9ut], value= jpioretvvc.y/127}
remote.handle_input(msg)
if jpioretvvc.y/127 ==1 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=uiqwassr[sdfhaae9ut], value= valogshi}
remote.handle_input(msg2)
end	
return true
elseif kxcver == 1 then 
local msg = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= jpioretvvc.y/127}
remote.handle_input(msg)
return true
end		
end
end
local jpioretvvc = remote.match_midi(nbtygllo, mhjk4we)
if jpioretvvc ~= nil then 
if jpioretvvc.x == 127 then
kxcver = 1
else
kxcver = 0 
local msg = {time_stamp=mhjk4we.time_stamp, item=lklertgzq, value= 0}
remote.handle_input(msg)
if sdfhaae9ut ~= 0 then 
local msg2 = {time_stamp=mhjk4we.time_stamp, item=sdf45weio[sdfhaae9ut], value= 0}
remote.handle_input(msg2)
return true
end	
end
end			 
end		
function remote_set_state(changed_items)
for i,imbtrdcx in ipairs(changed_items) do
if imbtrdcx>=9 and imbtrdcx<=16 then
for i =1, 8, 1 do 
if imbtrdcx == lkjvcds[i] then 
gfhjrsvb[i]=remote.get_item_value(imbtrdcx)
end	
end	
end	
if imbtrdcx>=29 and imbtrdcx <= 76 then
for i =1, 48, 1 do
if imbtrdcx == tcvnfhso[i] then 
pafgskjl[i] = remote.get_item_value(imbtrdcx)
end
end	
end
end	
end		
local function maewrgjj4f(ottre5j)
local i5tteioqq = pommnjhg[ottre5j]
local t43ekgvvf = gfhjrsvb[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 17}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
end
return mhjk4we
end	
local function tr43msdvred(ottre5j)
local i5tteioqq = ertgfsdgb[ottre5j]
local t43ekgvvf = pafgskjl[ottre5j]
if t43ekgvvf == 1 then
mhjk4we={144, i5tteioqq, 17}
mhjk4we.size = 3
else
mhjk4we={128, i5tteioqq, 29}
mhjk4we.size = 3
end	
return mhjk4we
end	
function remote_deliver_midi()
local d34jk5fds={}
for i = 1, 8, 1 do
if chjklwfd[i] ~= gfhjrsvb[i] then
local imbtrdcx = lkjvcds[i]
local mhjk4we = maewrgjj4f(i)
table.insert(d34jk5fds,mhjk4we)
chjklwfd[i] = gfhjrsvb[i]
end
end
for i = 1, 48, 1 do
if nfsvsxvzz[i] ~= pafgskjl[i] then
local imbtrdcx = tcvnfhso[i]
local mhjk4we = tr43msdvred(i)
table.insert(d34jk5fds,mhjk4we)
nfsvsxvzz[i] = pafgskjl[i]
end
end	
if kxcver ~= tslkfgnxz then 
if kxcver == 1 then 
local mhjk4we = remote.make_midi("b0 62 6f")
table.insert(d34jk5fds,mhjk4we)
elseif kxcver ==0 then 
local mhjk4we = remote.make_midi("b0 62 00")	
table.insert(d34jk5fds,mhjk4we)
end
tslkfgnxz = kxcver
end
return d34jk5fds
end
function remote_prepare_for_use()
local d34jk5fds = {}
for i =1, 48, 1 do 
local i5tteioqq = ertgfsdgb[i]
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
table.insert(d34jk5fds, mhjk4we)
end		
return d34jk5fds
end
function remote_release_from_use()
local d34jk5fds = {}
for i =1, 48, 1 do 
local i5tteioqq = ertgfsdgb[i]
mhjk4we={128, i5tteioqq, 0}
mhjk4we.size = 3
table.insert(d34jk5fds, mhjk4we)
end		
return d34jk5fds
end










